var path = require('path');

var webpack = require('webpack');

var packageData = require('./package.json');

module.exports = {
    entry: path.resolve(__dirname, packageData.main),
    output: {
        path: path.resolve(__dirname, 'build'),
        filename: [packageData.name, packageData.version,
                   'min', 'js'].join('.'),
        libraryTarget: 'var',
        library: packageData.name
    },
    devtool: 'source-map',
    module: {
      loaders: [
        {
          test: /\.js?$/,
          exclude: /(node_modules)/,
          loader: 'babel' // 'babel-loader' is also a legal name to reference
        }
      ]
    },
    plugins: [new webpack.optimize.UglifyJsPlugin()]
}
